#pragma once
#include <string>
#include <vector>

#include <abstraction/OperationAbstraction.hpp>

class Algorithm {
    friend class Registry;
public:

    struct Overload {
        Overload(std::string returnType, std::vector<std::string> parameterTypes);

        std::string returnType;
        std::vector<std::string> parameterTypes;
    };

    explicit Algorithm(std::string fullName);

    const std::vector<std::string>& getGroups() const { return this->groups; }

    const std::string& getFullName() const { return this->fullName; }
    std::string getPrettyName() const;

    size_t getInputCount() const;

    std::shared_ptr<abstraction::OperationAbstraction> execute(
            const std::vector<std::shared_ptr<abstraction::OperationAbstraction>>& params) const;

private:
    void addOverload(Overload overload);
    bool canAddOverload(const Overload& overload);

    std::string name;
    std::string fullName;
    std::vector<std::string> groups;
    std::vector<Overload> overloads;
};


