#pragma once

#include <tuple>

#if __has_include(<optional>) && __cplusplus >= 201703L //FIXME has_include to allow build on gitlab-ci with alpine 3.7
	#include <optional>
#else
	#include <experimental/optional>
	namespace std {
		template < class T >
		using optional = experimental::optional < T >;

		constexpr auto nullopt = std::experimental::nullopt;
	}
#endif

#include <QString>
#include <QImage>

#include <abstraction/OperationAbstraction.hpp>

namespace Converter {
    std::optional<QString> toString(const std::shared_ptr<abstraction::OperationAbstraction>& data);
    std::optional<QString> toDOT(const std::shared_ptr<abstraction::OperationAbstraction>& data);
    std::optional<QString> toXML(const std::shared_ptr<abstraction::OperationAbstraction>& data, bool indent = true);
    std::optional<QImage> toPNG(const std::shared_ptr<abstraction::OperationAbstraction>& data);

    std::shared_ptr<abstraction::OperationAbstraction> tryParse(const QString& input);
    std::shared_ptr<abstraction::OperationAbstraction> parseXML(const QString& xml);
    std::shared_ptr<abstraction::OperationAbstraction> parseText(const QString& txt);

    void saveToImage(const std::shared_ptr<abstraction::OperationAbstraction>& data, const QString& filename);
}


