/*
 * CastAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _CAST_ABSTRACTION_HPP_
#define _CAST_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>

namespace abstraction {

template < class ReturnType, class ParamType >
class CastAbstraction : public UnaryOperationAbstraction < ReturnType, ParamType > {
public:
	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		if ( this->cached ( ) )
			return true;

		this->m_data = ReturnType ( std::get < 0 > ( this->m_params )->getConstValueReference ( ) );

		return true;
	}
};

} /* namespace abstraction */

#endif /* _CAST_ABSTRACTION_HPP_ */
