/*
 * MemberAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _MEMBER_ABSTRACTION_HPP_
#define _MEMBER_ABSTRACTION_HPP_

#include <abstraction/NaryOperationAbstraction.hpp>
#include <alib/memory>
#include <registry/Registry.h>

namespace abstraction {

template < class ObjectType, class ReturnType, class ... ParamTypes >
class MemberAbstraction : public NaryOperationAbstraction < ReturnType, ObjectType &, ParamTypes ... > {
	std::function < ReturnType ( typename std::remove_reference < ObjectType >::type *, ParamTypes ... ) > m_callback;

public:
	MemberAbstraction ( std::function < ReturnType ( typename std::remove_reference < ObjectType >::type *, ParamTypes ... ) > callback ) : m_callback ( callback ) {
	}

	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		if ( this->cached ( ) )
			return true;

		this->member_run_helper ( m_callback, this->m_params, this->m_moves, std::make_index_sequence < sizeof ... ( ParamTypes ) > { } );
		return true;
	}

};

} /* namespace abstraction */

#endif /* _MEMBER_ABSTRACTION_HPP_ */
