/*
 * SetAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _SET_ABSTRACTION_HPP_
#define _SET_ABSTRACTION_HPP_

#include <abstraction/AnyaryOperationAbstraction.hpp>
#include <alib/memory>

namespace abstraction {

template < class ParamType >
class SetAbstraction : public AnyaryOperationAbstraction < ext::set < ParamType >, ParamType > {

public:
	SetAbstraction ( ) {
	}

	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		if ( this->cached ( ) )
			return true;

		ext::set < ParamType > theSet;
		for ( const std::pair < std::shared_ptr < ValueProvider < ParamType > >, bool > & param : this->m_params ) {
			theSet.insert ( param.first->getValue ( param.second ) );
		}

		this->m_data = theSet;

		return true;
	}

};

} /* namespace abstraction */

#endif /* _SET_ABSTRACTION_HPP_ */
