/*
 * StringReaderAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _STRING_READER_ABSTRACTION_HPP_
#define _STRING_READER_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>
#include <factory/StringDataFactory.hpp>

namespace abstraction {

template < class ReturnType >
class StringReaderAbstraction : public UnaryOperationAbstraction < ReturnType, std::string && > {
public:
	virtual bool run ( ) override {
		if ( this->isReady ( ) )
			return true;

		ReturnType res = factory::StringDataFactory::fromString ( std::get < 0 > ( this->m_params )->getRValueReference ( ) );
		this->m_data = std::move ( res );
		return true;
	}
};

} /* namespace abstraction */

#endif /* _STRING_READER_ABSTRACTION_HPP_ */
