/*
 * StringWriterAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _STRING_WRITER_ABSTRACTION_HPP_
#define _STRING_WRITER_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>
#include <factory/StringDataFactory.hpp>

namespace abstraction {

template < class ParamType >
class StringWriterAbstraction : public UnaryOperationAbstraction < std::string, const ParamType & > {
public:
	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		this->m_data = factory::StringDataFactory::toString ( std::get < 0 > ( this->m_params )->getConstValueReference ( ) );
		return true;
	}
};

} /* namespace abstraction */

#endif /* _STRING_WRITER_ABSTRACTION_HPP_ */
