/*
 * ValuePrinterAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _VALUE_PRINTER_ABSTRACTION_HPP_
#define _VALUE_PRINTER_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>
#include <abstraction/NullaryOperationAbstraction.hpp>

namespace abstraction {

template < class ParamType >
class ValuePrinterAbstraction : public UnaryOperationAbstraction < void, ParamType > {
	std::ostream & m_ostream;

public:
	ValuePrinterAbstraction ( std::ostream & os ) : m_ostream ( os ) {
	}

	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		m_ostream << std::get < 0 > ( this->m_params )->getConstValueReference ( ) << std::endl;
		return true;
	}
};

template < >
class ValuePrinterAbstraction < void > : public NullaryOperationAbstraction < void > {
public:
	ValuePrinterAbstraction ( std::ostream & ) {
	}

	virtual bool run ( ) override {
		return true;
	}
};

} /* namespace abstraction */

#endif /* _VALUE_PRINTER_ABSTRACTION_HPP_ */
