/*
 * XmlComposerAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _XML_COMPOSER_ABSTRACTION_HPP_
#define _XML_COMPOSER_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>
#include <factory/XmlDataFactory.hpp>

namespace abstraction {

template < class ParamType >
class XmlComposerAbstraction : public UnaryOperationAbstraction < ext::deque < sax::Token >, const ParamType & > {
public:
	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		this->m_data = factory::XmlDataFactory::toTokens ( std::get < 0 > ( this->m_params )->getConstValueReference ( ) );
		return true;
	}
};

} /* namespace abstraction */

#endif /* _XML_COMPOSER_ABSTRACTION_HPP_ */
