/*
 * XmlParserAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _XML_PARSER_ABSTRACTION_HPP_
#define _XML_PARSER_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>
#include <exception/CommonException.h>
#include <factory/XmlDataFactory.hpp>

namespace abstraction {

template < class ReturnType >
class XmlParserAbstraction : public UnaryOperationAbstraction < ReturnType, ext::deque < sax::Token > && > {

public:
	virtual bool run ( ) override {
		if ( this->isReady ( ) )
			return true;

		ReturnType res = factory::XmlDataFactory::fromTokens ( std::get < 0 > ( this->m_params )->getRValueReference ( ) );
		this->m_data = std::move ( res );
		return true;
	}
};

template < >
inline bool XmlParserAbstraction < exception::CommonException >::run ( ) {
	exception::CommonException ex = factory::XmlDataFactory::fromTokens ( std::get < 0 > ( this->m_params )->getRValueReference ( ) );
	throw ex;
}

} /* namespace abstraction */

#endif /* _XML_PARSER_ABSTRACTION_HPP_ */
