/*
 * XmlTokensComposerAbstraction.hpp
 *
 *  Created on: 7. 10. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _XML_TOKENS_COMPOSER_ABSTRACTION_HPP_
#define _XML_TOKENS_COMPOSER_ABSTRACTION_HPP_

#include <abstraction/BinaryOperationAbstraction.hpp>
#include <sax/SaxComposeInterface.h>

namespace abstraction {

class XmlTokensComposerAbstraction : public BinaryOperationAbstraction < void, const ext::deque < sax::Token > &, const std::string & > {
public:
	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		sax::SaxComposeInterface::composeFile ( std::get < 1 > ( this->m_params )->getConstValueReference ( ), std::get < 0 > ( this->m_params )->getConstValueReference ( ) );
		return true;
	}
};

} /* namespace abstraction */

#endif /* _XML_TOKENS_COMPOSER_ABSTRACTION_HPP_ */
