/*
 * XmlTokensParserAbstraction.hpp
 *
 *  Created on: 7. 10. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _XML_TOKENS_PARSER_ABSTRACTION_HPP_
#define _XML_TOKENS_PARSER_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>
#include <sax/SaxParseInterface.h>

namespace abstraction {

class XmlTokensParserAbstraction : public UnaryOperationAbstraction < ext::deque < sax::Token >, const std::string & > {
public:
	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		this->m_data = sax::SaxParseInterface::parseFile ( std::get < 0 > ( this->m_params )->getConstValueReference ( ) );
		return true;
	}
};

} /* namespace abstraction */

#endif /* _XML_TOKENS_PARSER_ABSTRACTION_HPP_ */
