/*
 * RankedSymbol.h
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#ifndef _STRING_RANKED_SYMBOL_H_
#define _STRING_RANKED_SYMBOL_H_

#include <common/ranked_symbol.hpp>
#include <core/stringApi.hpp>
#include <primitive/string/Unsigned.h>

namespace core {

template < class SymbolType, class RankType >
struct stringApi < common::ranked_symbol < SymbolType, RankType > > {
	static common::ranked_symbol < SymbolType, RankType > parse ( std::istream & input );
	static bool first ( std::istream & input );
	static void compose ( std::ostream & output, const common::ranked_symbol < SymbolType, RankType > & symbol );
};

template < class SymbolType, class RankType >
common::ranked_symbol < SymbolType, RankType > stringApi < common::ranked_symbol < SymbolType, RankType > >::parse ( std::istream & ) {
	throw exception::CommonException("parsing ranked symbol from string not implemented");
}

template < class SymbolType, class RankType >
bool stringApi < common::ranked_symbol < SymbolType, RankType > >::first ( std::istream & ) {
	return false;
}

template < class SymbolType, class RankType >
void stringApi < common::ranked_symbol < SymbolType, RankType > >::compose ( std::ostream & output, const common::ranked_symbol < SymbolType, RankType > & symbol ) {
	core::stringApi < SymbolType >::compose ( output, symbol.getSymbol ( ) );
	core::stringApi < RankType >::compose ( output, symbol.getRank ( ) );
}

} /* namespace core */

#endif /* _STRING_RANKED_SYMBOL_H_ */
