#ifndef _CLI_CONTAINER_STATEMENT_H_
#define _CLI_CONTAINER_STATEMENT_H_

#include <ast/Statement.h>
#include <ast/options/TypeOption.h>

namespace cli {

class ContainerStatement final : public Statement {
	std::string m_container;
	ext::vector < std::shared_ptr < Statement > > m_params;
	std::unique_ptr < TypeOption > m_type;
	ext::vector < bool > m_moves;

public:
	ContainerStatement ( std::string container, ext::vector < std::shared_ptr < Statement > > params, std::unique_ptr < TypeOption > type, ext::vector < bool > moves );

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & environment ) const override;

	virtual bool getImplicitMove ( ) const override {
		return true;
	}
};

} /* namespace cli */

#endif /* _CLI_CONTAINER_STATEMENT_H_ */
