#ifndef _IMMEDIATE_STATEMENT_H_
#define _IMMEDIATE_STATEMENT_H_

#include <ast/Statement.h>
#include <abstraction/ImmediateValueAbstraction.hpp>

namespace cli {

template < class Type >
class ImmediateStatement final : public Statement {
	Type m_data;

public:
	ImmediateStatement ( Type value ) : m_data ( std::move ( value ) ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & ) const override {
		return std::make_shared < abstraction::ImmediateValueAbstraction < Type > > ( m_data );
	}

	virtual bool getImplicitMove ( ) const override {
		return true;
	}
};

} /* namespace cli */

#endif /* _IMMEDIATE_STATEMENT_H_ */
