#ifndef _CLI_RESULT_PRINT_STATEMENT_H_
#define _CLI_RESULT_PRINT_STATEMENT_H_

#include <ast/Statement.h>
#include <global/GlobalData.h>
#include <registry/Registry.h>

namespace cli {

class ResultPrintStatement final : public Statement {
public:
	ResultPrintStatement ( ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & ) const override {
		std::shared_ptr < abstraction::OperationAbstraction > res = abstraction::Registry::getValuePrinterAbstraction ( prev->getReturnType ( ), common::Streams::out );

		if ( res->numberOfParams ( ) == 0 )
			return res;

		if ( ! res->attachInput ( prev, 0, false ) )
			throw std::invalid_argument ( "Can't connect param at 0 of result print statement with result of type " + prev->getReturnType ( ) + "." );
		if ( ! res->eval ( ) )
			throw std::invalid_argument ( "Eval of result print statement failed." );
		return res;
	}

	virtual bool getImplicitMove ( ) const override {
		return false;
	}

};

} /* namespace cli */

#endif /* _CLI_RESULT_PRINT_STATEMENT_H_ */
