#ifndef _CLI_RESULT_VARIABLE_STATEMENT_H_
#define _CLI_RESULT_VARIABLE_STATEMENT_H_

#include <ast/Statement.h>

namespace cli {

class ResultVariableStatement final : public Statement {
	std::unique_ptr < cli::Arg > m_name;

public:
	ResultVariableStatement ( std::unique_ptr < cli::Arg > name ) : m_name ( std::move ( name ) ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & environment ) const override {
		environment.setVariable ( m_name->eval ( environment ), prev );
		return prev;
	}

	virtual bool getImplicitMove ( ) const override {
		return false;
	}

};

} /* namespace cli */

#endif /* _CLI_RESULT_VARIABLE_STATEMENT_H_ */
