/*
 * Automaton.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef AUTOMATON_H_
#define AUTOMATON_H_

#include <type_traits>

namespace automaton {

/**
 * \brief Wrapper around any automaton type.
 */
class Automaton;

template < class T >
using SymbolTypeOfAutomaton = typename std::decay < decltype (std::declval<T>().getInputAlphabet()) >::type::value_type;

template < class T >
using StateTypeOfAutomaton = typename std::decay < decltype (std::declval<T>().getStates()) >::type::value_type;

} /* namespace automaton */

#endif /* AUTOMATON_H_ */
