/*
 * AutomatonFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef AUTOMATON_FROM_STRING_LEXER_H_
#define AUTOMATON_FROM_STRING_LEXER_H_

#include <alib/string>
#include <alib/istream>

namespace automaton {

class AutomatonFromStringLexer {
public:
	enum class TokenType {
		EPSILON_NFA,
		MULTI_INITIAL_STATE_NFA,
		NFA,
		DFA,
		OUT,
		IN,
		EPSILON,
		SEPARATOR,
		NONE,
		NEW_LINE,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	static Token next(std::istream & input);
	static Token peek(std::istream & input);
	static void putback ( std::istream&, const std::string & token);
	static void putback ( std::istream&, const Token & token);

	static bool test ( std::istream & input, const std::string & value );
	static void consume ( std::istream & input, const std::string & value );
	static bool testAndConsume ( std::istream & input, const std::string & value );
};

} /* namepsace automaton */

#endif /* AUTOMATON_FROM_STRING_LEXER_H_ */
