/*
 * ContainerFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef _CONTAINER_FROM_STRING_LEXER_H_
#define _CONTAINER_FROM_STRING_LEXER_H_

#include <alib/string>
#include <alib/istream>

namespace container {

class ContainerFromStringLexer {
public:
	enum class TokenType {
		VECTOR_BEGIN,
		VECTOR_END,
		SET_BEGIN,
		SET_END,
		PAIR_BEGIN,
		PAIR_END,
		COMMA,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	static Token next(std::istream& input);
	static void putback(std::istream& input, Token token);
};

} /* namespace container */

#endif /* _CONTAINER_FROM_STRING_LEXER_H_ */
