#ifndef __CHAR_SEQUENCE_ADAPTOR_H_
#define __CHAR_SEQUENCE_ADAPTOR_H_

#include <string>

namespace cli {

class CharSequenceBase {
protected:
	const char * linePtr;
	bool endOfTransmition = false;
	bool endOfSequence = false;

	virtual void fetch ( bool readNextLine ) = 0;

public:
	virtual ~CharSequenceBase ( ) noexcept = default;

	int getCharacter ( ) const {
		if ( * linePtr )
			return * linePtr;
		else
			return EOF;
	}

	void advance ( bool readNextLine ) {
		if ( * linePtr )
			++ linePtr;
		if ( * linePtr == '\0' )
			fetch ( readNextLine );
	}

	virtual std::string getLine ( ) const = 0;

	bool isEndOfTransmition ( ) const {
		return endOfTransmition;
	}

	bool isEndOfSequence ( ) const {
		return endOfSequence;
	}
};

} /* namespace cli */

#endif /* __CHAR_SEQUENCE_ADAPTOR_H_ */
