/*
 * PrimitiveFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef PRIMITIVE_FROM_STRING_LEXER_H_
#define PRIMITIVE_FROM_STRING_LEXER_H_

#include <alib/string>
#include <alib/istream>

namespace primitive {

class PrimitiveFromStringLexer {
public:
	enum class TokenType {
		STRING,
		INTEGER,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	static Token next(std::istream& input);
	static void putback(std::istream& input, Token token);
};

} /* namespace primitive */

#endif /* PRIMITIVE_FROM_STRING_LEXER_H_ */
