/*
 * RegExpToAutomaton.h
 *
 *  Created on: 11. 1. 2014
 *	  Author: Tomas Pecka
 */

#ifndef REG_EXP_TO_AUTOMATON_H_
#define REG_EXP_TO_AUTOMATON_H_

#include <alib/pair>

#include <regexp/formal/FormalRegExp.h>
#include <regexp/unbounded/UnboundedRegExp.h>

#include "ToAutomatonGlushkov.h"

namespace regexp {

namespace convert {

class ToAutomaton {
public:
	/**
	 * Performs conversion.
	 * @return FSM equivalent to original regular expression.
	 */
	template < class SymbolType >
	static automaton::NFA < SymbolType, ext::pair < SymbolType, unsigned > > convert ( const regexp::FormalRegExp < SymbolType > & regexp );
	template < class SymbolType >
	static automaton::NFA < SymbolType, ext::pair < SymbolType, unsigned > > convert ( const regexp::UnboundedRegExp < SymbolType > & regexp );

};

template < class SymbolType >
automaton::NFA < SymbolType, ext::pair < SymbolType, unsigned > > ToAutomaton::convert ( const regexp::FormalRegExp < SymbolType > & regexp ) {
	return ToAutomatonGlushkov::convert ( regexp );
}

template < class SymbolType >
automaton::NFA < SymbolType, ext::pair < SymbolType, unsigned > > ToAutomaton::convert ( const regexp::UnboundedRegExp < SymbolType > & regexp ) {
	return ToAutomatonGlushkov::convert ( regexp );
}

} /* namespace convert */

} /* namespace regexp */

#endif /* REG_EXP_TO_AUTOMATON_H_ */
