/*
 * ToGrammar.h
 *
 *  Created on: 6. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef REG_EXP_TO_GRAMMAR_H_
#define REG_EXP_TO_GRAMMAR_H_

#include "ToGrammarRightRGGlushkov.h"

namespace regexp {

namespace convert {

class ToGrammar {
public:
	/**
	 * Performs conversion.
	 *
	 * \tparam SymbolType type of symbols in the regexp
	 *
	 * \param regexp the converted regexp
	 *
	 * \return right regular grammar equivalent to source regexp.
	 */
	template < class SymbolType >
	static grammar::RightRG < SymbolType, ext::pair < SymbolType, unsigned > > convert(const regexp::FormalRegExp < SymbolType > & regexp);

	/**
	 * \overload
	 */
	template < class SymbolType >
	static grammar::RightRG < SymbolType, ext::pair < SymbolType, unsigned > > convert(const regexp::UnboundedRegExp < SymbolType > & regexp);

};

template < class SymbolType >
grammar::RightRG < SymbolType, ext::pair < SymbolType, unsigned > > ToGrammar::convert ( const regexp::FormalRegExp < SymbolType > & regexp ) {
	return ToGrammarRightRGGlushkov::convert ( regexp );
}

template < class SymbolType >
grammar::RightRG < SymbolType, ext::pair < SymbolType, unsigned > > ToGrammar::convert ( const regexp::UnboundedRegExp < SymbolType > & regexp ) {
	return ToGrammarRightRGGlushkov::convert ( regexp);
}

} /* namespace convert */

} /* namespace regexp */

#endif /* REG_EXP_TO_GRAMMAR_H_ */
