#ifndef _NORMALIZATION_REGISTRATION_HPP_
#define _NORMALIZATION_REGISTRATION_HPP_

#include <registry/NormalizeRegistry.hpp>

namespace registration {

template < class ReturnType, typename enable = void >
class NormalizationRegister {
public:
	NormalizationRegister ( ) {
	}

	bool requireNormalization ( ) const {
		return false;
	}
};

template < class ReturnType >
class NormalizationRegister < ReturnType, typename std::enable_if < ! std::is_same < ReturnType, core::normalizationResult < ReturnType > >::value >::type > {
public:
	NormalizationRegister ( ) {
		abstraction::NormalizeRegistry::registerNormalize < ReturnType > ( );
	}

	bool requireNormalization ( ) const {
		return true;
	}
};

} /* namespace registration */

#endif // _NORMALIZATION_REGISTRATION_HPP_
