/*
 * StringFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_FROM_STRING_LEXER_H_
#define STRING_FROM_STRING_LEXER_H_

#include <alib/string>
#include <alib/istream>

namespace string {

class StringFromStringLexer {
public:
	enum class TokenType {
		LESS,
		GREATER,
		QUOTE,
		EPSILON,
		TERM,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	static Token next(std::istream& input);
	static void putback(std::istream&, Token token);
};

} /* namespace string */

#endif /* STRING_FROM_STRING_LEXER_H_ */
