/*
 * RandomStringFactory.h
 *
 *  Created on: 27. 3. 2014
 *      Author: Jan Travnicek
 */

#ifndef RANDOM_STRING_FACTORY_H_
#define RANDOM_STRING_FACTORY_H_

#include <alib/set>
#include <string/LinearString.h>

namespace string {

namespace generate {

class RandomStringFactory {
public:
	static string::LinearString < > generateLinearString ( size_t size, size_t alphabetSize, bool randomizedAlphabet, bool integerSymbols );
	static string::LinearString < > generateLinearString ( size_t size, size_t alphabetSize, bool randomizedAlphabet );
	static string::LinearString < > generateLinearString ( size_t size, ext::set < DefaultSymbolType > alphabet );
};

} /* namespace generate */

} /* namespace string */

#endif /* RANDOM_STRING_FACTORY_H_ */
