/*
 * Epsilon.h
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#ifndef _STRING_EPSILON_H_
#define _STRING_EPSILON_H_

#include <string/Epsilon.h>
#include <core/stringApi.hpp>

#include <string/StringFromStringLexer.h>

#include <string/string/common/StringFromStringParserCommon.h>
#include <string/string/common/StringToStringComposerCommon.h>

namespace core {

template<class SymbolType >
struct stringApi < string::Epsilon < SymbolType > > {
	static string::Epsilon < SymbolType > parse ( std::istream & input );
	static bool first ( std::istream & input );
	static void compose ( std::ostream & output, const string::Epsilon < SymbolType > & string );
};

template<class SymbolType >
string::Epsilon < SymbolType > stringApi < string::Epsilon < SymbolType > >::parse ( std::istream & input ) {
	string::StringFromStringLexer::Token token = string::StringFromStringLexer::next ( input );
	if ( token.type == string::StringFromStringLexer::TokenType::EPSILON ) {
		return string::Epsilon < SymbolType > ( );
	} else {
		throw exception::CommonException ( "Unrecognised Epsilon token." );
	}
}

template<class SymbolType >
bool stringApi < string::Epsilon < SymbolType > >::first ( std::istream & input ) {
	string::StringFromStringLexer::Token token = string::StringFromStringLexer::next ( input );
	bool res = token.type == string::StringFromStringLexer::TokenType::EPSILON;
	string::StringFromStringLexer::putback ( input, token );
	return res;
}

template<class SymbolType >
void stringApi < string::Epsilon < SymbolType > >::compose ( std::ostream & output, const string::Epsilon < SymbolType > & ) {
	output << "#E";
}

} /* namespace core */

#endif /* _STRING_EPSILON_H_ */
