/*
 * Author: Radovan Cerveny
 */

#ifndef DAWG_MATCHER_CONSTRUCTION_H_
#define DAWG_MATCHER_CONSTRUCTION_H_

#include <indexes/stringology/SuffixAutomaton.h>
#include <string/LinearString.h>

namespace stringology {

namespace matching {

class DAWGMatcherConstruction {
public:
	 /**
	 * Linear time on-line construction of minimal suffix automaton for given pattern.
	 * @return minimal suffix automaton for given pattern.
	 */
	static indexes::stringology::SuffixAutomaton < > construct ( const string::LinearString < > & pattern );

};

} /* namespace matching */

} /* namespace stringology */

#endif /* DAWG_MATCHER_CONSTRUCTION_H_ */
