/*
 * Author: Radovan Cerveny
 */

#ifndef NAIVE_DAWG_MATCHER_CONSTRUCTION_H_
#define NAIVE_DAWG_MATCHER_CONSTRUCTION_H_

#include <automaton/FSM/DFA.h>
#include <string/LinearString.h>

namespace stringology {

namespace matching {

class NaiveDAWGMatcherConstruction {
public:
	/**
	 * Naive construction of minimal suffix automaton for given pattern - EpsNFA -> NFA -> DFA -> minDFA -> removeErrorState.
	 * @return minimal suffix automaton for given pattern.
	 */
	static automaton::DFA < DefaultSymbolType, ext::set < unsigned > > naiveConstruct ( const string::LinearString < > & pattern );

};

} /* namespace matching */

} /* namespace stringology */

#endif /* NAIVE_DAWG_MATCHER_CONSTRUCTION_H_ */
