/*
 * Author: Radovan Cerveny
 */

#ifndef ORACLE_MATCHER_CONSTRUCTION_H_
#define ORACLE_MATCHER_CONSTRUCTION_H_

#include <automaton/FSM/DFA.h>
#include <string/LinearString.h>

namespace stringology {

namespace matching {

class OracleMatcherConstruction {
public:
	 /**
	 * Linear time on-line construction of minimal suffix automaton for given pattern.
	 * @return minimal suffix automaton for given pattern.
	 */
	static automaton::DFA < DefaultSymbolType, unsigned > construct ( const string::LinearString < > & pattern );

};

} /* namespace matching */

} /* namespace stringology */

#endif /* ORACLE_MATCHER_CONSTRUCTION_H_ */
